package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        anywheresoftware.b4a.keywords.Common.ToastMessageShow("This application was developed with Basic4android trial version and should not be distributed.", true);
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.WebViewWrapper _webview1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.WebViewWrapper _webview2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public anywheresoftware.b4a.objects.Timer _timer_refresh = null;
public anywheresoftware.b4a.objects.WebViewWrapper _webview3 = null;
public anywheresoftware.b4a.objects.WebViewWrapper _webview4 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button5 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button6 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 41;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 43;BA.debugLine="Activity.LoadLayout(\"main\")";
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 //BA.debugLineNum = 45;BA.debugLine="WebView1.LoadHtml(\"<html><body><img src='http://www.foto-webcam.com/webcam/BrauneckKarwendel/current/400.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview1.LoadHtml("<html><body><img src='http://www.foto-webcam.com/webcam/BrauneckKarwendel/current/400.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 46;BA.debugLine="WebView2.LoadHtml(\"<html><body><img src='http://www.foto-webcam.com/webcam/BrauneckSpeichersee/2013/09/29/1200_lm.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview2.LoadHtml("<html><body><img src='http://www.foto-webcam.com/webcam/BrauneckSpeichersee/2013/09/29/1200_lm.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 47;BA.debugLine="WebView3.LoadHtml(\"<html><body><img src='http://www.fw-tegernsee.de/webcam/prasserbad/2013/09/29/1200_lm.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview3.LoadHtml("<html><body><img src='http://www.fw-tegernsee.de/webcam/prasserbad/2013/09/29/1200_lm.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 48;BA.debugLine="WebView4.LoadHtml(\"<html><body><img src='http://www.foto-webcam.eu/webcam/zellamsee/2013/09/29/1200_lm.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview4.LoadHtml("<html><body><img src='http://www.foto-webcam.eu/webcam/zellamsee/2013/09/29/1200_lm.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 56;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 58;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 52;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 54;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
 //BA.debugLineNum = 72;BA.debugLine="Sub Button1_Click";
 //BA.debugLineNum = 73;BA.debugLine="Activity_Create(True)";
_activity_create(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 76;BA.debugLine="End Sub";
return "";
}
public static String  _button2_click() throws Exception{
 //BA.debugLineNum = 77;BA.debugLine="Sub Button2_Click";
 //BA.debugLineNum = 78;BA.debugLine="Activity.LoadLayout(\"vollbild\")";
mostCurrent._activity.LoadLayout("vollbild",mostCurrent.activityBA);
 //BA.debugLineNum = 82;BA.debugLine="WebView1.LoadHtml(\"<html><body><img src='http://webcam.otrate.de/Otrate.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview1.LoadHtml("<html><body><img src='http://webcam.otrate.de/Otrate.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 84;BA.debugLine="End Sub";
return "";
}
public static String  _button3_click() throws Exception{
 //BA.debugLineNum = 85;BA.debugLine="Sub Button3_Click";
 //BA.debugLineNum = 86;BA.debugLine="Activity.RemoveAllViews";
mostCurrent._activity.RemoveAllViews();
 //BA.debugLineNum = 87;BA.debugLine="Activity_Create(True)";
_activity_create(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 88;BA.debugLine="End Sub";
return "";
}
public static String  _button4_click() throws Exception{
 //BA.debugLineNum = 89;BA.debugLine="Sub Button4_Click";
 //BA.debugLineNum = 90;BA.debugLine="Activity.LoadLayout(\"vollbild\")";
mostCurrent._activity.LoadLayout("vollbild",mostCurrent.activityBA);
 //BA.debugLineNum = 94;BA.debugLine="WebView1.LoadHtml(\"<html><body><img src='http://webcameldenburg.bootsurlaub.de/webcam/marina.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview1.LoadHtml("<html><body><img src='http://webcameldenburg.bootsurlaub.de/webcam/marina.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 95;BA.debugLine="End Sub";
return "";
}
public static String  _button5_click() throws Exception{
 //BA.debugLineNum = 96;BA.debugLine="Sub Button5_Click";
 //BA.debugLineNum = 97;BA.debugLine="Activity.LoadLayout(\"vollbild\")";
mostCurrent._activity.LoadLayout("vollbild",mostCurrent.activityBA);
 //BA.debugLineNum = 99;BA.debugLine="WebView1.LoadHtml(\"<html><body><img src='http://medien.aida.de/webcam/aidablu_ahead_625px.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview1.LoadHtml("<html><body><img src='http://medien.aida.de/webcam/aidablu_ahead_625px.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 100;BA.debugLine="End Sub";
return "";
}
public static String  _button6_click() throws Exception{
 //BA.debugLineNum = 101;BA.debugLine="Sub Button6_Click";
 //BA.debugLineNum = 102;BA.debugLine="Activity.LoadLayout(\"vollbild\")";
mostCurrent._activity.LoadLayout("vollbild",mostCurrent.activityBA);
 //BA.debugLineNum = 104;BA.debugLine="WebView1.LoadHtml(\"<html><body><img src='http://webcam.kuhnle-tours.de/pics/webcam-nid.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview1.LoadHtml("<html><body><img src='http://webcam.kuhnle-tours.de/pics/webcam-nid.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 105;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 25;BA.debugLine="Dim WebView1 As WebView";
mostCurrent._webview1 = new anywheresoftware.b4a.objects.WebViewWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim WebView2 As WebView";
mostCurrent._webview2 = new anywheresoftware.b4a.objects.WebViewWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim Button2 As Button";
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim timer_refresh As Timer";
mostCurrent._timer_refresh = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 31;BA.debugLine="timer_refresh.Initialize(\"timer_refresh\",60000)";
mostCurrent._timer_refresh.Initialize(processBA,"timer_refresh",(long)(60000));
 //BA.debugLineNum = 32;BA.debugLine="timer_refresh.Enabled = True";
mostCurrent._timer_refresh.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 35;BA.debugLine="Dim WebView3 As WebView";
mostCurrent._webview3 = new anywheresoftware.b4a.objects.WebViewWrapper();
 //BA.debugLineNum = 36;BA.debugLine="Dim WebView4 As WebView";
mostCurrent._webview4 = new anywheresoftware.b4a.objects.WebViewWrapper();
 //BA.debugLineNum = 37;BA.debugLine="Dim Button5 As Button";
mostCurrent._button5 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 38;BA.debugLine="Dim Button6 As Button";
mostCurrent._button6 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _timer_refresh_tick() throws Exception{
 //BA.debugLineNum = 60;BA.debugLine="Sub timer_refresh_tick";
 //BA.debugLineNum = 61;BA.debugLine="WebView1.LoadHtml(\"<html><body><img src='http://webcam.otrate.de/Otrate.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview1.LoadHtml("<html><body><img src='http://webcam.otrate.de/Otrate.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 62;BA.debugLine="WebView2.LoadHtml(\"<html><body><img src='http://webcameldenburg.bootsurlaub.de/webcam/marina.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview2.LoadHtml("<html><body><img src='http://webcameldenburg.bootsurlaub.de/webcam/marina.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 63;BA.debugLine="WebView3.LoadHtml(\"<html><body><img src='http://medien.aida.de/webcam/aidablu_ahead_625px.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview3.LoadHtml("<html><body><img src='http://medien.aida.de/webcam/aidablu_ahead_625px.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 64;BA.debugLine="WebView4.LoadHtml(\"<html><body><img src='http://webcam.kuhnle-tours.de/pics/webcam-nid.jpg?' width='100%' height='100%'/></body></html>\")";
mostCurrent._webview4.LoadHtml("<html><body><img src='http://webcam.kuhnle-tours.de/pics/webcam-nid.jpg?' width='100%' height='100%'/></body></html>");
 //BA.debugLineNum = 65;BA.debugLine="End Sub";
return "";
}
public static String  _webview1_pagefinished(String _url) throws Exception{
 //BA.debugLineNum = 69;BA.debugLine="Sub WebView1_PageFinished (Url As String)";
 //BA.debugLineNum = 71;BA.debugLine="End Sub";
return "";
}
}
